<?php

namespace HS\Install\System\Checks;

use HS\Install\System\SystemCheckInterface;

class HasAppKey implements SystemCheckInterface
{
    /**
     * If system check is valid (OK).
     * @var bool
     */
    protected $valid;

    /**
     * Error.
     * @var string
     */
    protected $error;


    /**
     * This is required to pass.
     * @return bool
     */
    public function required()
    {
        return true;
    }

    /**
     * Check if the app key enviroment var exist.
     * @return bool
     */
    public function valid()
    {
        if (config('app.key') !== '' && config('app.key') !== null) {
            $this->valid = true;
        }

        if (! $this->valid) {
            $this->error = '.env file is missing an APP_KEY value. Run php hs install:key. More information found here https://support.helpspot.com/index.php?pg=kb.page&id=657.';
            $this->valid = false;
         }

        return $this->valid;
    }

    /**
     * @return mixed
     */
    public function getError()
    {
        return $this->error;
    }
}
